//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "EHS_DemoUnit1.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "ehsbase"
#pragma link "ehscontextmap"
#pragma link "ehshelprouter"
#pragma link "ehsWhatsThis"
#pragma link "ehsbase"
#pragma link "ehscontextmap"
#pragma link "ehshelprouter"
#pragma link "ehswhatsthis"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::cbActiveChange(TObject *Sender)
{
    WhatsThis1->Active    = static_cast<bool>(cbActive->ItemIndex);
    btnWhatsThis->Enabled = WhatsThis1->Active;
    mnuWhatsThis->Enabled = WhatsThis1->Active;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::cbF1ActionChange(TObject *Sender)
{
    WhatsThis1->F1Action = TF1Action(cbF1Action->ItemIndex);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::cbHelpTypeChange(TObject *Sender)
{
    if (cbHelpType->ItemIndex == 0)
    {
        HelpRouter1->HelpType = htWinhelp;
    }
    else
    {
        if (!HelpRouter1->HTMLhelpInstalled())
        {
           HelpRouter1->HelpType = htWinhelp;
           cbHelpType->ItemIndex = 0;
           MessageDlg("Cannot load HTML HELP OCX control.\nHelp mode is reset to Winhelp format.",
                      mtError,
                      TMsgDlgButtons() << mbOK,
                      0);
        }
        else if (cbHelpType->ItemIndex == 1)
        {
           HelpRouter1->HelpType = htHTMLhelp;
        }
        else
        {
           HelpRouter1->HelpType = htMixedMode;
        }

    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ContextOptionsClick(TObject *Sender)
{
    TWhatsThisOption    wtOption;
    TWhatsThisOptions   wtOptionSet;

    TCheckBox *CB = dynamic_cast<TCheckBox *>(Sender);
    if (CB != NULL)
    {
        if      (CB == cbwtDirectHelp)          wtOption = wtDirectHelp;
        else if (CB == cbwtMenuRightClick)      wtOption = wtMenuRightClick;
        else if (CB == cbwtNoContextHelp)       wtOption = wtNoContextHelp;
        else if (CB == cbwtNoContextMenu)       wtOption = wtNoContextMenu;
        else if (CB == cbwtPopupOnForm)         wtOption = wtPopupOnForm;
        else if (CB == cbwtInheritFormContext)  wtOption = wtInheritFormContext;
        else if (CB == cbwtUseTag)              wtOption = wtUseTag;
        else if (CB == cbwtUseAppKey)           wtOption = wtUseAppKey;

        wtOptionSet = WhatsThis1->Options;
        if (CB->Checked)
            wtOptionSet << wtOption;
        else
            wtOptionSet >> wtOption;
        WhatsThis1->Options = wtOptionSet;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
    Application->HelpFile    = ChangeFileExt(Application->ExeName, ".hlp");
    PageControl1->ActivePage = TabWhatsThis;
    cbActive->ItemIndex      = static_cast<int>(WhatsThis1->Active);
    cbF1Action->ItemIndex    = static_cast<int>(WhatsThis1->F1Action);
    cbHelpType->ItemIndex    = static_cast<int>(HelpRouter1->HelpType);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MenuDummyClick(TObject *Sender)
{
    AnsiString Msg;

    Msg  = "This menu item is a dummy and does nothing.\n";
    Msg += "There is, however, context sensitive help available for every item.\n";
    Msg += "Just right-click a menu item to display it's help topic.";

    MessageDlg(Msg, mtInformation, TMsgDlgButtons() << mbOK, 0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mnuExitClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mnuHelpFTSClick(TObject *Sender)
{
    Application->HelpCommand(15, -1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mnuHelpKeywordsClick(TObject *Sender)
{
    HelpRouter1->HelpKeyword("");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mnuHelpTOCClick(TObject *Sender)
{
    HelpRouter1->HelpContent();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PopupmenuforListbox11Click(TObject *Sender)
{
    AnsiString Msg;

    Msg  = "Listbox1 has it's own popup menu that appears after a right mouse click.\n";
    Msg += "TWhatsThis automatically recognizes popup menus and does NOT display a What's this? menu in this case.\n";
    Msg += "This even works with popup menus that your program may display manually in the OnMouseUp event.";

    MessageDlg(Msg, mtInformation, TMsgDlgButtons() << mbOK, 0);
}
//---------------------------------------------------------------------------
