unit uZZ_ChangeLog;
interface

procedure DeveloperComments;
function getDeveloperComments: String;

procedure DeveloperCommentsPar;
implementation

uses fZZ_EventLog,
  Classes
  , SysUtils
  , Forms
  , uZZ_VersionInfo
  ;

procedure DeveloperComments;
begin
  addTextEvent('Developer Comments', getDeveloperComments);
end;

procedure addToDo(SL: TStringList);
begin
  if SL = nil then
    exit;
  SL.Add('ToDo List:');
//  SL.Add('        508 mode');
//  SL.Add('        Updated Comments dialog');

end;

procedure addConditionals(SL: TStringList);
begin
  if SL = nil then
    exit;
  SL.Add('Compiled with Conditionals:');
{$IFDEF CAS_DDPE_DEBUG}SL.Add('        CAS_DDPE_DEBUG   - debug screen elements enabled'); {$ENDIF}
{$IFDEF CAS_508_DEBUG}SL.Add('        CAS_508_DEBUG    - debug of 508 mode '); {$ENDIF}
{$IFDEF CAS_DDPE_RST}SL.Add('        CAS_DDPE_RST     - Removal STatus elements enabled'); {$ENDIF}
{$IFDEF CAS_DDPE_TEST}SL.Add('        CAS_DDPE_TEST    - developer functionality enabled'); {$ENDIF}
{$IFDEF MSF_ON}SL.Add('        MSF_ON'); {$ENDIF}
{$IFDEF MSF_OFF}SL.Add('        MSF_OFF'); {$ENDIF}
{$IFDEF MOB2}SL.Add('        MOB2'); {$ENDIF}
{$IFDEF MOB2_OFF}SL.Add('        MOB2_OFF'); {$ENDIF}
{$IFDEF DEBUGLOG_OFF}SL.Add('        DEBUGLOG_OFF'); {$ENDIF}
{$IFDEF DEBUGLOG_ON}SL.Add('        DEBUGLOG_ON'); {$ENDIF}
{$IFDEF TEST_OFF}SL.Add('        TEST_OFF'); {$ENDIF}
{$IFDEF TEST_ON}SL.Add('        TEST_ON'); {$ENDIF}
{$IFDEF ACTIVECTRL_OFF}SL.Add('        ACTIVECTRL_OFF'); {$ENDIF}
{$IFDEF ACTIVECTRL_ON}SL.Add('        ACTIVECTRL_ON'); {$ENDIF}
{$IFDEF R1224198}SL.Add('        R1224198         - code to address INC 1224198'); {$ENDIF}
{$IFDEF R960057}SL.Add('        R960057          - code to address INC 960057'); {$ENDIF}
{$IFDEF INC984066}SL.Add('        INC984066          - code to address INC984066'); {$ENDIF}
{$IFDEF ZZ_RPC_LOG}SL.Add('        ZZ_RPC_LOG       - RPC Log window included'); {$ENDIF}

{$IFDEF CAS_DDPE_MAPEDIT}SL.Add('        CAS_DDPE_MAPEDIT - Anatomical Location Setup'); {$ENDIF}
end;

function getDeveloperComments: String;
var
  SL: TStringList;
begin
  SL := TStringList.Create;
  SL.Add(getExeNameVersion);
  SL.Add('');
//  AddToDo(SL);
//  SL.Add('');
  AddConditionals(SL);
  SL.Add('Build 3.0.96.15');
  SL.Add('Corrections:');
  SL.Add('  BCMA_Utils.padr function pads strings with unreadable chars. Fixed');
  SL.Add('Build 3.0.96.14');
  SL.Add('  Field testing of PSB*3.0*96 modifications.');
  SL.Add('Corrections:');
  SL.Add('  Bar Code Reader is not activated after cancalation of an action - addressed by:');
  SL.Add('    commenting out "OnActivate" method of the main window and re-enabling processing of ');
  SL.Add('    WM_Activate message');
  SL.Add('Build 3.0.96.13');
  SL.Add('  Field testing of PSB*3.0*96 modifications.');
  SL.Add('Code changes:');
  SL.Add('  ZZ_RPC_LOG conditional removed. This conditional was used fo both DEBUG and RELEASE modes');
  SL.Add('  Fixed A/V error on accessing RPC Log when application is closing');
  SL.Add('  Labels of fPRNMedLog updated to red color');
  SL.Add('');
  SL.Add('Build 3.0.96.10');
  SL.Add('Enhancement:');
  SL.Add('  Patch PSB*3.0*96 - Support of 2FA.');
  SL.Add('Correction:');
  SL.Add('  Fixed resources strings for both DEBUG and RELEASE modes.');
  SL.Add('  Modified menu sort to display correct items, dropped Administration Time.');
  SL.Add('  Parameters: Edit layout duplicate convert lowercase input to uppercase.');
  SL.Add('  Parameters: Save location data on default answer list.');
  SL.Add('');
  SL.Add('Build 3.0.83.36');
  SL.Add('Enhancement:');
  SL.Add('  Modified Edit Med Log to hide body site and label if no body site specified (held, refused, missing).');
  SL.Add('  Also hide IV Bag Number label if not an IV.');
  SL.Add('  Simplified Given MRRs popup to show only discontinued orders.');
  SL.Add('  Dropped Late/Late-RM for Clinic Orders.');
  SL.Add('  Modified process to hide Clinic (inpatient mode) and HSM (clinic mode) columns on VDL.');
  SL.Add('  User-selected widths are now preserved.');
  SL.Add('Build 3.0.83.35');
  SL.Add('Enhancement:');
  SL.Add('  Added save of sort columns across order mode.');
  SL.Add('  Modified next dose action to treat Held or Refused as needing no further action.');
  SL.Add('  Modified display of given MRR to show regardless of VDL start/stop time window.');
  SL.Add('  Added dermal site input to Edit Med Log.');
  SL.Add('  Parameters: Merged body sites with body chart on default answer tab and update edit layout.  Enhance body site list to support location coordinates.');
  SL.Add('  Parameters: Added 2-way select in body site list / default answer list.');
  SL.Add('  Parameters: On body site item add or edit, add to master list also from default answer list save and from edit layout save.');
  SL.Add('  Parameters: Save background image to vista if missing.');
  SL.Add('Correction:');
  SL.Add('  Fixed hover hints to be in sync with current tab.');
  SL.Add('  Modified menu sort to display correct items, dropped Administration Time.');
  SL.Add('  Parameters: Edit layout duplicate convert lowercase input to uppercase.');
  SL.Add('  Parameters: Save location data on default answer list.');
  SL.Add('');
  SL.Add('Build 3.0.83.34');
  SL.Add('Enhancement:');
  SL.Add('  Dropped Close Patient MRR check.  Added Open Patient MRR check.');
  SL.Add('Build 3.0.83.33');
  SL.Add('Correction:');
  SL.Add('  Fixed Coversheet display of headers and grid lines after refresh; Issue Tracker #29.');
  SL.Add('  Changed display of Given MRR orders to display when Removal Due Time prior to VDL stop times.');
  SL.Add('Enhancement:');
  SL.Add('  Added support for dermal sites with Dermal Site Needed and Dermal Site History.  Menus changed to Body Site History.');
  SL.Add('  Added Site in Witness form to display dermal or injection site.');
  SL.Add('  /DEBUGLOG: added entry when have MRR and internal injectionsiteneeded, flag is reset to False.');
  SL.Add('');
  SL.Add('Build 3.0.83.32');
  SL.Add('Correction:');
  SL.Add('  Updated VDL window start/stop time window handling for MRR and late in Inpatient IVP/IVPB and Clinic Orders Unit Dose and IVP/IVPB.');
  SL.Add('  Modified PRN and OnCall to show no Next Dose Action.');
  SL.Add('  Modified Provider Hold to not show Late or Late-RM.');
  SL.Add('  Fixed Header Sort Direction Arrows to display in sort column used for tab selected.');
  SL.Add('');
  SL.Add('Build 3.0.83.31');
  SL.Add('Correction:');
  SL.Add('  Fixed MultOrder form to display Witness icon, Removal icon correctly, and Removal status correctly.');
  SL.Add('  Dropped default IMAT in CAS_DDPE_DEBUG mode in Patient Select.');
  SL.Add('  Corrected Late handling in VDL time window.');
  SL.Add('  Corrected Remove which did not need a confirm.');
  SL.Add('  Corrected Remove to show Prior or After on Confirm as appropriate.');
  SL.Add('  Corrected VDL time window test to show MRR orders before start time only if given, pending removal.');
  SL.Add('    The MRR given, pending removal dose will show only if it''s removal time is prior to the stop time.');
  SL.Add('');
  SL.Add('Build 3.0.83.30');
  SL.Add('Correction:');
  SL.Add('  Changed Next Dose Action DateTime back to display when no further action to be taken on that administration.');
  SL.Add('');
  SL.Add('Build 3.0.83.29');
  SL.Add('Fixed Defects:');
  SL.Add('  Modified Next Dose Action to show black text, no status, and datetime on second line on non-MRR with Give scan status.');
  SL.Add('  Corrected hints to show same status text as Next Dose Action.');
  SL.Add('  Changed Next Dose Action DateTime to blank when no further action to be taken on that admin.');
  SL.Add('');
  SL.Add('Build 3.0.83.28');
  SL.Add('Fixed Defects:');
  SL.Add('  Fixed crash due to accessing non-existant admin time column on IV tab.');
  SL.Add('');
  SL.Add('Build 3.0.83.27');
  SL.Add('Fixed Defects:');
  SL.Add('  Fixed late time calculation to allow for missing data, e.g., no administration time.');
  SL.Add('');
  SL.Add('Build 3.0.83.26');
  SL.Add('Fixed Defects:');
  SL.Add('  Fixed Mark Held/Refused to pass action correctly prior to logging order.');
  SL.Add('  Fixed non-MRR give which incorrectly showed REMOVE.');
  SL.Add('  Fixed Confirmation to correctly check for comment text in order to allow close of form.');
  SL.Add('Enhancements:');
  SL.Add('  Added LATE and LATE-RM logic and display in red on Unit Dose and IVP/IVPB tabs as well as Multiple Orders.');
  SL.Add('  Changed column name from Next Action to Next Dose Action.');
  SL.Add('');
  SL.Add('Build 3.0.83.25');
  SL.Add('Fixed Defects:');
  SL.Add('  Fixed access violation crash when displaying multiple orders or medlog / confirmation window.');
  SL.Add('  Fixed height calculation for VDL row with Special Instructions.');
  SL.Add('  Fixed height calculation for Multiple Order window row.');
  SL.Add('Enhancements:');
  SL.Add('  Modified Next Action column to write action and date/time on separate lines.  Allowed column to expand.');
  SL.Add('');
  SL.Add('Build 3.0.83.24');
  SL.Add('Fixed Dev Tickets:');
  SL.Add('  #7: Too Late information dialog is missing the text description.');
  SL.Add('  #9: The Requires Removal patch icon did not display on the Cover Sheet for a medication that was set to have a removal icon and was Given.');
  SL.Add('Enhancements:');
  SL.Add('  Coversheet: added logic to show Missed-RM for missed removal in Next Action column.');
  SL.Add('  MultOrder: fixed display of Next Action and Last Action.');
  SL.Add('');
  SL.Add('Build 3.0.83.23');
  SL.Add('Fixed Dev Tickets:');
  SL.Add('  #8: Unable to Scan button disabled incorrectly sometimes.');
  SL.Add('  #11: Alert column resize too small to display icons.');
  SL.Add('  #12: Next Action column allowed resize too wide and displayed date next to action.');
  SL.Add('');
  SL.Add('Build 3.0.83.22');
  SL.Add('      - MOB2 disabled - no support of the BCMAOrderCom.dll v.2.0.0.0');
  SL.Add('      - form frmCAS_Confirmation removed from the project');
  SL.Add('');
  SL.Add('Build 3.0.83.21');
  SL.Add('      - Default width of the Alert column increased to suit fixed position of the RR icon');
  SL.Add('      - RPC "PSB VALIDATE ORDER" parameter 10 added (Removal time). See getValidOrder function');
  SL.Add('      - Implementation of 508 mode updated for MultiOrders window');
  SL.Add('        The "Alert" and "Next Action" columns text updated to match non 508 mode');
  SL.Add('      - Validation logic of UD orders changed: ');
  SL.Add('          prior to build 21 only first validation of orders with the Administration Units of "PATCH" was calling RPC.');
  SL.Add('          The subsequent validation requests were not using RPC to check the order validity.');
  SL.Add('          v.3.0.83.21 validates UD of "PATCH" by calling RPC every time the validation is requested');
  SL.Add('   FIXED:');
  SL.Add('      - No Logging of the REMOVE action (Code was ignoring Validation statuses different from "1"');
  SL.Add('');
  SL.Add('Build 3.0.83.20');
  SL.Add('      - RR icon position fixed to the right of the HighRisk icon');
  SL.Add('   FIXED:');
  SL.Add('      - RPC "PSB VALIDATE ORDER" Next Action time format updated (changed to string in FM format)');
  SL.Add('');
  SL.Add('Build 3.0.83.19');
  SL.Add('      - RPC "PSB VALIDATE ORDER" changed to pass Next Action time instead of Administration Time');
  SL.Add('      - Adding comment if Removal Confirmation is successful (Early and Late removal confirmation comment)');
  SL.Add('   FIXED:');
  SL.Add('      - Misspelling (Main window, Alert Legend: "Hight" instead of "High")');
  SL.Add('      - "Next Action" column delimiter (Main window, UD tab: was "-" in build 18, reset to " ")');
  SL.Add('');
  SL.Add('Build 3.0.83.18');
  SL.Add('      - Confirmation dialog with Comments on Early Removal');
  SL.Add('      - Confirmation dialog with Comments on Late Removal');
  SL.Add('      - Confirmation message on closing Patient record');
  SL.Add('      - Updated parameters list of PSB TRANSACTION RPC');
  SL.Add('        For MEDPASS event the parameter array includes new element [10]');
  SL.Add('        that contains RemovalDateTime in FM format');
  SL.Add('        (same value as the one received from RPCs: PSB GETORDERTAB, PSB COVERSHEET1)');
  SL.Add('      - Next Action column of the VDL is sorted by date the next action is scheduled');
  SL.Add('   FIXED:');
  SL.Add('      - Duplicate time in Next Action Column of VDL (UD tab)');
  SL.Add('      - Incorrect indication of MRR on coversheet');
  SL.Add('        (RR icon was shown for all orders that contained given MRR regardless the last action on the order');
  SL.Add('         changed so that RR icon is shown only if the latest action on the order was "G")');

  SL.Add('');
  SL.Add('Build 3.0.83.17');
  SL.Add('      - Legend dialog updated to include "Requires Removal" icon');
  SL.Add('      - Logic of NextAction Time changed. ');
  SL.Add('        For MRR orders with status "G" the RemovalTime is used in NextAction column');
  SL.Add('        otherwise (not MRR, MRR and not "G" status) the AdminTime is used');
  SL.Add('      - Removal DateTime added as [10]th element of array passed to "PSB TRANSACTION" RPC');
  SL.Add('      - "Remove" option is enabled for MRR items with status "G"');

  SL.Add('');
  SL.Add('Build 3.0.83.16');
  SL.Add('      - Removal Flag added to the parameters of "PSB TRANSACTION" RPC');
  SL.Add('        (See "^MEDPASS" call for details)');
  SL.Add('');
  SL.Add('Build 3.0.83.15');
  SL.Add('      - The default appearance of GUI adjusted (still can be changed via Debug menu');
  SL.Add('      - "Admin Time" column hidden.');
  SL.Add('      - "Legend" action disabled.');
  SL.Add('        The action controls position of the Legend on the screen');
  SL.Add('      - "RR Icon" action disabled.');
  SL.Add('        The action controls selection of the icon representing MRR items');
  SL.Add('      - Remedy 1224198 addressed. (Requires conditional R1224198)');
  SL.Add('      - Removal Flag added to the parameters of "PSB TRANSACTION" RPC');
  SL.Add('        (See "^UPDATE STATUS" call for details)');
  SL.Add('   FIXED:');
  SL.Add('      - "Invalid Patient Lookup" message if the /CAS_PID is not assigned ');
  SL.Add('');
  SL.Add('Build 3.0.83.14');
  SL.Add('      - Multi Item Order dialog updated to implement RR icons in "Alert" column');
  SL.Add('      - "Active Control" menu option added to DEBUG menu.');
  SL.Add('        The option replaces the User name on the Status bar with');
  SL.Add('        the name of the active control');
  SL.Add('      - Legend for "Alert" column added to the IV tab');
  SL.Add('      - If /CAS_PID parameter is assigned the application is bypassing selector Dlg');
  SL.Add('        for example: adding /CAS_PID=000001313 to the target line of the shortcut');
  SL.Add('        will force application to open confirmation dialog for Pt. 000001313');
  SL.Add('        (works at the application start only)');
  SL.Add('      - Developer Notes option added to the DEBUG section of the main menu');
  SL.Add('      - Sort indicator added to VDL table header');
  SL.Add('      - Scanner Enabled button position adjusted based on available space');
  SL.Add('      - "Alert Legend" of CS limited to 2 icons');
  SL.Add('      - "Alert Legend" adjusted to the right');
  SL.Add('      - RR Icon updated');
  SL.Add('');

  SL.Add('Build 3.0.83.13');
  SL.Add('      - Cover Sheet "Alert" column expanded to fit RR icon');
  SL.Add('      - Cover Sheet RR icon shown for items with status "G" (GIVEN) only)');
  SL.Add('      - IV, IVP/IVPB "Wit" columns changed to "Alert"');
  SL.Add('      - RR column removed from VDL');
  SL.Add('Build 3.0.83.12');
  SL.Add('      - Scanner button moved');
  SL.Add('      - Hint to the Required removal icon updated');
  SL.Add('      - Legend aligned to the left');
  SL.Add('      - Debug menu updated');

  SL.Add('Build 3.0.83.11');
  SL.Add('      - Various icons for RR status');
  SL.Add('Build 3.0.83.10');
  SL.Add('      - GUI main window min width increased from 750 t0 900');

  SL.Add('Build 3.0.83.9');
  SL.Add('      - GUI shows RR icon for MedOrders of MRR flag 0: FIXED');
  SL.Add('      - DEBUG Menu updated to include:');
  SL.Add('        - selection of RR Icon');
  SL.Add('        - selection of position of RR Icon Legend');
  SL.Add('        - height of the VDL record');

  SL.Add('Build 3.0.83.8');
  SL.Add('      - GUI fails to save MedOrder: FIXED');

  SL.Add('Build 3.0.83.7');
  SL.Add('      - CAS_DDPE_DEBUG conditional added');
  SL.Add('      - Raw Order option added to the VDL local menu. (CAS_DDPE_DEBUG conditional only)');
  SL.Add('        Option opens information dialog with Med Order data');
  SL.Add('      - "RPC GETORDERTAB" results processing includes pieces 34,35 (MRR code, Remove Date/Time');
  SL.Add('        VDL table updated to show "Remove DateTime" for MRR codes 1,2,3');
  SL.Add('      - VDL Legend updated');

  SL.Add('Build 3.0.83.6');
  SL.Add('      - Next Action is calculated based on ScanStatus not LastActivityStatus');
  SL.Add('Build 3.0.83.5');
  SL.Add('      - Injection Site dialog debug mode added: to change captions in Debug mode');
  SL.Add('      - 508 Mode is not showing "Next Action": FIXED');
  SL.Add('      - Cover Sheet tab: column header changed from "Wit" to "Alert"');
  SL.Add('      - "Cover Sheet Legend" option added to DEBUG menu');
  SL.Add('      - RR Icon changed');
  SL.Add('      - FIXED: "Med Log" option of the DEBUG menu');
  SL.Add('      - "Med Log" period selector updated');

  SL.Add('Build 3.0.83.4');
  SL.Add('      - the DEBUG section added to the main menu');
  SL.Add('      - the debug 508 mode could not be disabled: FIXED');
  SL.Add('      - the debug options added: switching between 1 or 2 lines in Next Action column');
  SL.Add('      - the debug options added: switching between 1 or 2 icons in Alert column');
  SL.Add('      - the debug options added: editing of the VDL Headers');

  SL.Add('Build 3.0.83.3');
  SL.Add('      - Unit Dose Legend Panel added. Access to the panel via "View|Unit Dose Legend"');
  SL.Add('      - Column caption changed: "Wit" -> "Alert", "Witness Required" - > "Alert"');
  SL.Add('      - Med Log Tab updated. Enhances control of the Calendar');
  SL.Add('Build 3.0.83.2');
  SL.Add('      - Rebuild after changes units common with BCMAPar.exe v.3.0.83.2');
  SL.Add('Build 3.0.83.1');
  SL.Add('      - Additional button (v.3) added to the "Select Injection" dialog');
  SL.Add('Build 3.0.83.0');
  SL.Add('      - version required updated');
  SL.Add('      - Anatomic Location Selector added');
  SL.Add('Build 3.0.70.77:');
  SL.Add('      - Code optimization');
  SL.Add('Build 3.0.70.76:');
  SL.Add('      - VDL Cover and UnitDose tabs updated to use the same indicators of');
  SL.Add('        the TRANSDERMAL orderable items.');
  SL.Add('Build 3.0.70.75:');
  SL.Add('      - VDL Cover tab updated to include indicators/hints on status of ');
  SL.Add('        the TRANSDERMAL orderable items.');
  SL.Add('Build 3.0.70.74:');
  SL.Add('      - "RR" column added to VDL Cover tab.');
  SL.Add('        (Enabled when compiled with CAS_DDPE_RST conditional)');
  SL.Add('        For "TRANSDERMAL" routes the column contains image');
  SL.Add('        notifying the item requires removal. ');
  SL.Add('Build 3.0.70.73:');
  SL.Add('      - "R St." column added to VDL/UD tab.');
  SL.Add('        (Enabled when compiled with CAS_DDPE_RST conditional)');
  SL.Add('        For "TRANSDERMAL" routes the column contains images');
  SL.Add('        representing status of the medication. ');
  SL.Add('        Current version supports 2 images: ');
  SL.Add('             White - for items with "REMOVED" included in Last Action');
  SL.Add('             Green - for all other values');
  SL.Add('      - /CAS_PID startup parameter added');
  SL.Add('        (Enabled when compiled with CAS_DDPE_TEST conditional)');
  SL.Add('        Lets you specify patient id at startup like: /CAS_PID=666991000');
  SL.Add('      - Hints added to the VDL table');
  SL.Add('        (Enabled when compiled with CAS_DDPE_RST conditional)');
  SL.Add('Build 3.0.70.72:');
  SL.Add('      - /CAS_READER parameter added');
  SL.Add('        (Enabled when compiled with CAS_DDPE_TEST conditional)');
  SL.Add('        When included in the parameter string the Scan Wrist Band dialog');
  SL.Add('        reveals the input field.');
  SL.Add('        (Enter the SSN in the field to emulate scanning)');
  SL.Add('   FIXED:');
  SL.Add('      - The RPC Log is not available after patient selector is called');
  SL.Add('Build 3.0.70.71:');
  SL.Add('      - Tab "Med Log" added to the VDL');
  SL.Add('        The tab provides access to the medication log data');
  SL.Add('        Note: the Med Log comments are pulled by the "DDR LISTER" RPC');
  SL.Add('              "DDR LISTER" is RESTRICTED RPC of the FMDC package');
  SL.Add('              "DDR LISTER" uses named parameters for Broker call');
  SL.Add('        (Enabled when compiled with CAS_DDPE_TEST conditional)');
  SL.Add('Build 3.0.70.70:');
  SL.Add('      - Option "508" added to the Tools section of the main menu');
  SL.Add('        When checked the GUI mimics the screen reader interface');
  SL.Add('        Note: in this build only main form is affected!');
  SL.Add('Build 3.0.70.69:');
  SL.Add('      - /CAS_IGNORE parameter will disable verification of the DLL');
  SL.Add('        (Enabled when compiled with CAS_DDPE_TEST conditional)');
  SL.Add('      - Sample implementation of Injection Selection List updated');
  SL.Add('Build 3.0.70.68:');
  SL.Add('      - Pt Lookup dialog defaults to "TEST"');
  SL.Add('      - mVitals.pas added to the project');
  SL.Add('      - Sample implementation of Injection Selection List based on TListBox');
  SL.Add('Build 3.0.70.67:');
  SL.Add('      - Developer Comments item added to the RPC Log');
  SL.Add('        (Enabled when compiled with CAS_DDPE_TEST conditional)');
  SL.Add('Build 3.0.70.66:');
  SL.Add('      - RPC Log Added ');
  SL.Add('        (Enabled when compiled with CAS_DDPE_TEST conditional)');
  SL.Add('      - /AV parameter added (Requires conditional "CAS_DDPE_TEST")');

  Result := SL.Text;
  SL.Free;
end;

procedure DeveloperCommentsPar;
var
  SL: TStringList;
begin
  SL := TStringList.Create;
  SL.Add(getExeNameVersion);
  SL.Add('');
  addConditionals(SL);
  SL.Add('');

  SL.Add('Build 3.0.83.4');
  SL.Add('      - new conditional CAS_DDPE_V1 - implementation of "Anatomic Locations" list only');
  SL.Add('      - The Body Chart diagram is hidden');
  SL.Add('      - The "Anatomic Locations" tab is hidden but still available from DEBUG menu');
  SL.Add('      - the DEBUG menu added.');
  SL.Add('      - the "RPC Log" option moved to the DEBUG menu');
  SL.Add('Build 3.0.83.3');
  SL.Add('      - Anatomic Location Group implemention updated:');
  SL.Add('        Master list presentation as TListBox');
  SL.Add('        Group list presentation as TCheckListBox');
  SL.Add('        Master list help text added');
  SL.Add('      - Initial position of the application window changed to "Screen Center"');
  SL.Add('Build 3.0.83.2');
  SL.Add('      - Coordinates parameter name changed to "PSB LIST ANATOMIC LOCATIONS"');
  SL.Add('      - Anatomic Location Group implemention started');
  SL.Add('Build 3.0.83.1');
  SL.Add('      - "Anatomical" -> "Anatomic"');
  SL.Add('Build 3.0.83.0');
  SL.Add('      - version required updated');
  SL.Add('      - Anatomic Location Selector added');
  SL.Add('Build 3.0.70.12:');
  SL.Add('      - Map Editor added');
  SL.Add('        Map Editor uses new RPC: "PSB GETSETWP"');
  SL.Add('        The background image is saved as "PSB MAP BACKGROUND" parameter');
  SL.Add('        Coordinates of the locations are saved in "PSB LIST ANATOMICAL LOCATIONS"');
  SL.Add('Build 3.0.70.11:');
  SL.Add('      - Developer Comments item added to the RPC Log');
  SL.Add('Build 3.0.70.10:');
  SL.Add('      - RPC Log Added (Requires conditional "CAS_DDPE_TEST")');
  SL.Add('      - /AV parameter added (Requires conditional "CAS_DDPE_TEST")');
  addTextEvent('Developer Comments', SL.Text);
  SL.Free;
end;

// W&A
// why do we need 2 VHA_Objects.pas modules?
// SSO usage

end.

